// This program is designed for OKI-E5003 board
// It shows how to work with UART and SIO interface

#include <ioml67q5003.h>
#include "uart.h"
#include "sio.h"
#include "system.h"

// simple delay
void Delay (unsigned long a) { while (--a!=0); }

unsigned char ch1 = 0x0;
unsigned char ch2 = 0x0;

int main()
{

  // Freq init
  FreqInit();

  // InitSio
  InitSIO();

  // InitUart
  InitUART();


  // loop forever
  while(1) {

    //echo UART0 -> USB
    ch1 = ReadCharUART0_nonstop();
    if(ch1 != 0)
    {
      WriteCharUART0(ch1);
      WriteCharUART0('*');
      ch1 = 0;
    }

    //test SIO -> RS232
    ch2 = sioReadChar_nontop();
    if(ch2 != 0)
    {
      sioWriteChar(ch2);
      sioWriteChar('*');
      ch2 = 0;
    }


  }
}
