//sio.c
#include "sio.h"

#define CCLK          (7500000L)                                              //CCLK (Hz)
#define CGBGR         (1)                                                     //clock gear
#define CLKSIO        (CCLK/CGBGR)                                            //frequency CLKSIO (Hz)
//#define BAUDRATE      (115200)                                              //baud rate of SIO (baud)
#define BAUDRATE      (9600)                                                  //baud rate of SIO (baud)
//#define VALUE_OF_SIO  ((256 * (16 * BAUDRATE) - CLKSIO) / (16 * BAUDRATE))    //value of SIOBT register
#define VALUE_OF_SIO  (256 - (CCLK/(16*BAUDRATE)))                            //value of SIOBT register

void Delayf (unsigned long a) { while (--a!=0); }

// init SIO interface
void InitSIO()
{
    SIOBCN = 0x00;   //stop baud rate timer
    SIOSTA = 0x37;   //clear SIOSTA
    SIOCON = 0x00;   //clear SIOCON
    SIOBT  = 0x00;   //clear SIOBT
    SIOTCN = 0x00;   //clear SIOTCN

    SIOBT = VALUE_OF_SIO;
    SIOCON_bit.LN   = 0x0;  //8bit
    SIOCON_bit.PEN  = 0x0;  //none parity
    SIOCON_bit.TSTB = 0x1;  //1 stop bit

    GPCTL_bit.GPCTL1 = 1;   //set second function of port B.


    // HCLK and CCLK clock signals  = 1/8 from base clock.
    CGBCNT0   = 0x003c;   // key value
    CGBCNT0   = 0x0033;

    // HCLK and CCLK clock signals  =  from base clock.
    //CGBCNT0   = 0x003c;   // key value
    //CGBCNT0   = 0x0000;
    //start baud rate timer
    SIOBCN    = 0x0010;

    SIOBUF = 0x0;
}

// write char
void sioWriteChar(unsigned char data)
{
  //while(SIOSTA_bit.TRIRQ != 1);
  SIOSTA_bit.TRIRQ = 0;
  SIOBUF = data;
}

// read char
unsigned char sioReadChar(void)
{
  while(SIOSTA_bit.RVIRQ != 1);
  SIOSTA_bit.RVIRQ = 0;
  return SIOBUF;
}

// read char whitout stop
unsigned char sioReadChar_nontop(void)
{
  if(SIOSTA_bit.RVIRQ == 1)
  {
    SIOSTA_bit.RVIRQ = 0;
    return SIOBUF;
  }
  else return 0;
}

