//uart.c
#include "uart.h"

void InitUART(void)
{
  //Baud rate frequency = CCLK/(devisor x 16)
  //devisor = CCLK/(Baud rate frequency x 16)
  //CCLK = 14 745 600
  //Baud rate frequency = 9 600
  //calculate -> devisor = 0x60
  //
  //CCLK = 20 000 000
  //Baud rate frequency = 9 600
  //calculate -> devisor = 0x83
  //
  //CCLK = 4 000 000
  //Baud rate frequency = 9 600
  //calculate -> devisor = 0x1A
  //
  //CCLK = 7 500 000
  //Baud rate frequency = 9 600
  //calculate -> devisor = 0x30
  //
  //CCLK = 60 000 000
  //Baud rate frequency = 9 600
  //calculate -> devisor = 0x180


  // NOTICE!!! CCLK is 7 500 000 Hz


  unsigned short divisor = 0x0;

  divisor = 0x30;

  UARTFCR_bit.FCR0   = 0x1;
  UARTFCR_bit.FCR1   = 0x1;
  UARTFCR_bit.FCR2   = 0x1;
  UARTFCR_bit.FCR76  = 0x3;

  UARTLCR_bit.LCR10  = 0x3;           //8 bit
  UARTLCR_bit.LCR2   = 0x0;           //1 stop bit
  UARTLCR_bit.LCR3   = 0x0;           //no parity
  UARTLCR_bit.LCR7   = 0x1;           //enable DLAB

  UARTDLL = divisor & 0xFF;           //set low byte from the 16-bit divisor latch for the baud rate generator.
  UARTDLM = (divisor >> 8) & 0xFF;    //set igh byte from the 16-bit divisor latch for the baud rate generator.
  UARTLCR_bit.LCR7   = 0x0;           //disable DLAB

  GPCTL_bit.GPCTL0 = 1;               //set second function of port.

}

void WriteCharUART0(unsigned char a)
{
  //while (UARTLSR_bit.LSR5 == 0);
  while (UARTLSR_bit.LSR5 != 1);
  UARTTHR = a;
}
void WriteCharUART1(unsigned char a)
{
  //LATER
}

unsigned char ReadCharUART0(void)
{
  //while (UARTLSR_bit.LSR0 == 0);
  while (UARTLSR_bit.LSR0 != 1);
  return UARTRBR;
}

unsigned char ReadCharUART0_nonstop(void)
{
  //while (UARTLSR_bit.LSR0 == 0);
  if(UARTLSR_bit.LSR0 == 1)  return UARTRBR;
  else return 0;
}

unsigned char ReadCharUART1(void)
{
  //LATER
  return 0;
}

